gLevelValues.exitCastleLevel = 26
gLevelValues.exitCastleArea = 1
gLevelValues.exitCastleWarpNode = 10

gLevelValues.metalCapDuration = 900
gLevelValues.wingCapDuration = 1800
gLevelValues.vanishCapDuration = 1050

gLevelValues.mushroom1UpHeal = 1

save_file_set_flags(SAVE_FLAG_HAVE_METAL_CAP)
save_file_set_flags(SAVE_FLAG_HAVE_VANISH_CAP)
save_file_set_flags(SAVE_FLAG_HAVE_WING_CAP)

---@param m MarioState
local function mario_update(m)
    if m.playerIndex ~= 0 then return end

    ---@type NetworkPlayer
    local np = gNetworkPlayers[0]

    if m.numLives < 100 then
        m.numLives = 100
    end

    stop_cap_music()

    m.peakHeight = m.pos.y

    if m.action == ACT_EMERGE_FROM_PIPE and m.actionTimer <= 1 and np.currLevelNum == LEVEL_SSL then
        m.pos.y = m.pos.y + 50
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)